<?php
/**
 * @package JS Calendar Event for Joomla! 1.5
 * @version $Id: administrator/components/com_jscalendar/controller.php 1.5.7 2010-10-20 11:53:24 $
 * @author JoomlaSeller.com
 * @copyright (C) 2010- JoomlaSeller.com
 *
 * JoomlaSeller Calendar Event is a free software. You may make changes but
 * you may not sell it
 *
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 *
 * jscalendar controller for JS Calendar Event component
 * @email webmaster@joomlaseller.com
 *
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

//remove notice msg from lay_out
ini_set('error_reporting',E_ALL ^ E_NOTICE); 

jimport('joomla.application.component.controller');

/**
 * JS Calendar Event Component Controller
 *
 * @package    JS Calendar
 * @subpackage Components
 */
class JSCalendarController extends JController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
		// Register Extra tasks
		$this->registerTask( 'apply','save' );
		$this->registerTask( 'unpublish', 'publish' );
		$this->registerTask( 'orderdown', 'order' );
		$this->registerTask( 'orderup', 'order' );			
	}
	
	/**
	 * display events
	 * @return void
	 */
	function display(){
		JRequest::setVar( 'view', 'JSCalendar' );
		JRequest::setVar( 'layout', 'default'  );
		//JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	/**
	 * html  for add new event
	 * @return void
	 */	
	function add(){
		$model 	=& $this->getModel( 'JSCalendar' );
		$view 	=& $this->getView( 'JSCalendar', '.html' );
		$view->setModel( $model, true );
		$view->add();
	}	
	
	
	/**
	 * return to main component
	 *
	 */
	function cancel() {
		$this->setRedirect('index.php?option=com_jscalendar&view=jscalendar');
	}	
	
	/**
	 * save new event
	 * @return void
	 */	
	function save(){
		global $mainframe;
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );	
	
		$model =& $this->getModel('JSCalendar');
		$msg = $model->save();
		
		//set the msg to display
		foreach($msg["msg"]["message"] as $message_row => $message_value){
			$mainframe->enqueueMessage($message_value,$msg["msg"]["type"][$message_row]);
		}		
		
		if(JRequest::getVar('task') == 'apply'){
			$db	=& JFactory::getDBO();
			if($db->insertId()){
				$cid = $db->insertId();
			}else{
				$cid = JRequest::getVar( 'id' );			
			}
			$this->setRedirect('index.php?option=com_jscalendar&view=jscalendar&task=edit&cid[]='.$cid);
		}else{
			$this->setRedirect('index.php?option=com_jscalendar&view=jscalendar');
		}
	}
	
	/**
	 * delete an event
	 * @return void
	 */	
	function remove(){
		$model =& $this->getModel('JSCalendar');
		$msg = $model->delete();
		
		$this->setRedirect( 'index.php?option=com_jscalendar&view=jscalendar', $msg);	
	}
	
	/**
	 * edit event
	 *
	 */
	function edit() {
		$model 	=& $this->getModel( 'JSCalendar' );
		$view 	=& $this->getView( 'JSCalendar', '.html' );
		$view->setModel( $model, true );
		$view->edit();
	}
	
	/**
	 * publish or unpubish event
	 *
	 */
	function publish() {
		$model =& $this->getModel( 'JSCalendar' );
		$task = JRequest::getCmd('task');
		if ($task == 'publish') {
			$model->publish(1);
		} elseif ($task == 'unpublish') {
			$model->publish(0);
		} 
		
		$this->setRedirect('index.php?option=com_jscalendar&view=jscalendar');
	}	
	
	/**
	 * Method order up(-1)/down(1) an event with one record
	 *
	 * $ordering = int current ordering value
	 * $uid		 = int moved category id
	 * $inc		 = int up(-1)/down(1)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */	
	function order(){
		global $mainframe;
		$model =& $this->getModel('JSCalendar');
		$msg = $model->order();		
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest('limitstart', 'limitstart', 0, 'int');

		$link = 'index.php?option=com_jscalendar&view=jscalendar&limitstart='.$limitstart.'&limit='.$limit;
		$this->setRedirect($link, $msg);			
		
		return true;		
	}
	
	/**
	 * Method to save new order to an event 
	 *
	 * $ordering = int current ordering value
	 * $uid		 = int moved category id
	 * $inc		 = int up(-1)/down(1)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */	
	function saveorder(){
		global $mainframe;
		$model =& $this->getModel('JSCalendar');
		$msg = $model->saveorder();		
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest('limitstart', 'limitstart', 0, 'int');

		$link = 'index.php?option=com_jscalendar&view=jscalendar&limitstart='.$limitstart.'&limit='.$limit;
		$this->setRedirect($link, $msg);			
		
		return true;		
	}	

}
?>